• HDU 1087 Super Jumping! Jumping! Jumping!【DP】


    解题思路:题目的大意是给出一列数,求这列数里面最长递增数列的和

    dp[i]表示到达地点i的最大值,那么是如何达到i的呢,则我们可以考虑没有限制条件时候的跳跃,即可以从第1,2,3,---,i-1个地点跳跃到i,

    而题目限定了,跳到的那个点的数要比开始跳的那个点的数大

    所以,状态转移方程式为

    for(i=1;i<=n;i++)
       for(j=0;j<i;j++)

    if(a[j]>a[i])
       dp[i]=max(dp[j]+a[i],dp[i]);//找出到达地点i的最大值

    反思:本来想的是如果给了n个点的话,那么我再加一个点,则n+1点变成终点,则不管怎么跳,都会到达终点,所以dp[n+1]即为所求

    不过没有写出来,最后还是每次求出一个dp的值来比较求到了最大值。

    Super Jumping! Jumping! Jumping!

    Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 23935    Accepted Submission(s): 10519

    Problem Description
    Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good boy, and know little about this game, so I introduce it to you now.
    The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path. Your task is to output the maximum value according to the given chessmen list.
     
    Input
    Input contains multiple test cases. Each test case is described in a line as follow: N value_1 value_2 …value_N It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int. A test case starting with 0 terminates the input and this test case is not to be processed.
     
    Output
    For each case, print the maximum according to rules, and one line one case.
     
    Sample Input
    3 1 3 2 4 1 2 3 4 4 3 3 2 1 0
     
    Sample Output
    4 10 3
     
    #include<stdio.h>
    #include<string.h>
    #include<algorithm>
    using namespace std;
    int dp[1005],a[1005];
    int main()
    {
    	int n,i,j,maxx;
    	while(scanf("%d",&n)!=EOF&&n)
    	{	
    		memset(dp,0,sizeof(dp));
    			maxx=dp[0];
    		for(i=1;i<=n;i++)
    		scanf("%d",&a[i]);		
    		for(i=1;i<=n;i++)
    		{
    			for(j=0;j<i;j++)
    			{	
    			dp[i]=max((dp[j]+a[i])*(a[i]>a[j]),dp[i]);
    	      	if(dp[i]>maxx)
    		      maxx=dp[i];
    		    }
    		}
    		printf("%d
    ",maxx);		
    	}
    }
    

      

  • 相关阅读:
    c++ 迷宫问题
    linux下恢复删除的文件
    c++ 分解数2
    c++ 平分石头
    多态
    设计模式中类的6种关系
    工厂方法模式
    设计原则之面向接口编程
    封装、继承
    便利构造器、单件模式
  • 原文地址:https://www.cnblogs.com/wuyuewoniu/p/4208149.html
Copyright © 2020-2023  润新知